/* ------------------------------------------------------------------- 
* Header files 
* ------------------------------------------------------------------- */ 
#include "device.h"
#include "LED_Blink_Flash.h"
/* ------------------------------------------------------------------- 
* MACROs
* ------------------------------------------------------------------- */ 
#if 1// switch between 408 & 403 EZ-KITs
// LED2 macros for 408 board (PortE, bit6)
#define LED2_PORT    pADI_PORTE
#define LED2_PIN     0x40
#else
// LED2 macros for 403 board (PortB, bit4)
#define LED2_PORT    pADI_PORTB
#define LED2_PIN     0x10
#endif

#define LED2_ON      LED2_PORT->DATA_SET
#define LED2_OFF     LED2_PORT->DATA_CLR

/* ------------------------------------------------------------------- 
* Global Functions 
* ------------------------------------------------------------------- */ 
void CallSomeFlashCode(int BlinkCnt);

/* ---------------------------------------------------------------------- 
* Flash based LED blink code 
* ------------------------------------------------------------------- */ 
int main()
{
    /* system initialization with CMSIS API*/
    SystemInit();                       
        
    /* configure PortA, pin0 for output */
    LED2_PORT->DIR_SET = LED2_PIN;
        
    /* configures CGU, SPI */
    #ifdef SET_CLOCKS
    ConfigureClocks();
    #endif
    
    /* Configures the flash in XIP mode */
    #ifdef PLACE_FLASH 
      #ifdef XIP_ENABLE
        Set_MemMap_XIP();
      #endif
    #endif
    
    /* Configure cache with or without prefetch enabled */
    #ifndef BYPASS_CACHE
      #ifdef PREFETCH_ENABLE
        CacheEnablePrefetch();
      #endif
    #endif
        
    #ifdef BYPASS_CACHE
    ByPassCache();
    #endif
    
    /* call the function inside flash*/
    CallSomeFlashCode(2000000);
    
}

/*
    This is the function that is placed inside Internal SPI Flash
    defining MACRO PLACE_FLASH places this on to flash memory
*/
#ifdef PLACE_FLASH
  #pragma location = ".flash_code"
#endif
void CallSomeFlashCode(int BlinkCnt)
{
    int Cnt,i;    
   
    /* loop foreever and keep blinking */
      while(1)
     {           
    
            LED2_ON = LED2_PIN;
            for(Cnt=0;Cnt<BlinkCnt;Cnt++);
                      
            LED2_OFF = LED2_PIN;
            for(Cnt=0;Cnt<BlinkCnt;Cnt++);
            
      }
   
}

